Subject: bug#23747: bug present without emacs25 or notmuch

From: David Bremner <[email-masked]>
Date: Thu, 08 Sep 2016 21:43:13 -0300

I have managed to duplicate (I think) this bug without notmuch or emacs
25.

In emacs 24.5.1 (on debian)

(require 'mml2015)
(setq mml2015-sign-with-sender t)

M-x toggle-debug-on-error

M-x message-mail
(fill in some headers, From: me)
C-c C-m C-s
C-c C-c

yields the following backtrace

Debugger entered--Lisp error: (wrong-type-argument char-or-string-p nil)
  mml2015-epg-sign((part (sign . "pgpmime") (tag-location . 189) (contents . "\nTesty McTestface\n")))
  mml2015-sign((part (sign . "pgpmime") (tag-location . 189) (contents . "\nTesty McTestface\n")))
  mml-pgpmime-sign-buffer((part (sign . "pgpmime") (tag-location . 189) (contents . "\nTesty McTestface\n")))
  mml-generate-mime-1((part (sign . "pgpmime") (tag-location . 189) (contents . "\nTesty McTestface\n")))
  mml-generate-mime()
  message-encode-message-body()
  message-send-mail(nil)
  message-send-via-mail(nil)
  message-send(nil)
  message-send-and-exit(nil)
  call-interactively(message-send-and-exit nil nil)
  command-execute(message-send-and-exit)

I hazard a guess this is related to the changes in the with-colons
format of gnupg 2.1.15, since I just installed that to fix some other
breakage. I could be wrong though, I haven't debugged further than this.

If this message arrives signed, then a workaround is to set
mml2015-sign-with-sender to nil, although I'm not sure what will happen
with key selection.

d